/*
 * Copyright (c) 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __DOTNET_LAUNCHER_H__
#define __DOTNET_LAUNCHER_H__

#include "launcher.h"
#include "coreclr_host.h"
#include "plugin_manager.h"

namespace tizen {
namespace runtime {
namespace dotnetcore {

class CoreRuntime
{
	public:
		CoreRuntime(const char* mode);
		~CoreRuntime();
		int initialize(bool standalone);
		void dispose();
		int launch(const char* appId, const char* root, const char* path, int argc, char* argv[]);

	private:
		bool initializeCoreClr(const char* appId, const char* assemblyProbePaths, const char* pinvokeProbePaths, const char* tpaList);
		coreclr_initialize_ptr initializeClr;
		coreclr_execute_assembly_ptr executeAssembly;
		coreclr_shutdown_ptr shutdown;
		coreclr_create_delegate_ptr createDelegate;
		std::string __nativeLibDirectory;
		void* __coreclrLib;
		void* __hostHandle;
		unsigned int __domainId;
		int fd;
		const char* __mode;
		bool __initialized;
};

}  // dotnetcore
}  // namespace runtime
}  // namespace tizen

#endif /* __DOTNET_LAUNCHER_H__ */